*** pixutils.c	2004/05/07 19:46:16	1.1
--- pixutils.c	2005/01/16 20:25:17
***************
*** 133,144 ****
  #include "repres.h"
  #include "render.h"
  #include "font.h"
! 
! #ifdef INVERT
! #define InvertY(y) (y)
! #else
! #define InvertY(y) (-(y))
! #endif
  
  /* Sutherland-Cohen Line Clipping Macros */
  #define BitAbove    0x01
--- 157,163 ----
  #include "repres.h"
  #include "render.h"
  #include "font.h"
! #include "langsel.h"
  
  /* Sutherland-Cohen Line Clipping Macros */
  #define BitAbove    0x01
***************
*** 150,160 ****
  
  #define Reject(x,y)   ((x)&(y))
  #define Accept(x,y)   (!((x)|(y)))
- #define RootSix       2.44948974278
- 
- /* These define light source position */
- #define LightDot(x,y,z)  ((x)+InvertY(y)+(z)+(z))
- #define LightLength      RootSix
  
  
  typedef struct {
--- 169,174 ----
***************
*** 170,182 ****
  
  
  /* Note: DrawCylinderCaps currently employs an
!  *       extremely crude hack to avoid stripes
!  *       appearing along cylinders.
   */
! #define ARCSIZE  2048
  
  static ArcEntry __far *ArcAcPtr;
  static ArcEntry __far *ArcDnPtr;
  #if defined(IBMPC) || defined(APPLEMAC)
  static ArcEntry __far *ArcAc;
  static ArcEntry __far *ArcDn;
--- 184,199 ----
  
  
  /* Note: DrawCylinderCaps currently employs an
! *      extremely crude hack to avoid stripes
! *      appearing along cylinders.
   */
! #define ARCSIZE  4096
  
  static ArcEntry __far *ArcAcPtr;
  static ArcEntry __far *ArcDnPtr;
+ static ArcEntry __far *OCircle;
+ static ArcEntry __far *NCircle;
+ static ArcEntry __far *TCircle;
  #if defined(IBMPC) || defined(APPLEMAC)
  static ArcEntry __far *ArcAc;
  static ArcEntry __far *ArcDn;
***************
*** 184,204 ****
  static ArcEntry ArcAc[ARCSIZE];
  static ArcEntry ArcDn[ARCSIZE];
  #endif
  
  static char FontDimen[23];
  static int FontWid[97];
  static int ClipStatus;
  
  
  
! #define SETPIXEL(dptr,fptr,d,c)    if( (d) > *(dptr) )              \
!                                    {   *(dptr) = (d);               \
!                                        *(fptr) = (c);               \
                                     }
! #define SETPIXELP(dptr,fptr,d,c,ca,p) if( (d) > *(dptr))            \
!                                    {   *(dptr) = (d);               \
!                                        if(!p) {*(fptr) = (c); }      \
!                                        else  {*(fptr) = (ca);}      \
                                     }
  
  #define OutCode(res,x,y,z)            \
--- 201,241 ----
  static ArcEntry ArcAc[ARCSIZE];
  static ArcEntry ArcDn[ARCSIZE];
  #endif
+ static int OR, NR, ODots, NDots;
+ static Long C[3], A[3];
+ static Long Cprev[3], Cnext[3];
+ 
+ static int radprev, radnext, rad, rada, c;
+ 
  
  static char FontDimen[23];
  static int FontWid[97];
  static int ClipStatus;
  
+ /*
+     The following two macros add a pixel to the z-buffer
+ 
+     dptr-- a pointer to an array of depths
+     fptr-- a pointer to an array of pixels
+     View.shift a- on offset into the arrays
+     d   -- the depth of the new pixel
+     c   -- the color of the new pixel
+     ca  -- an alternate color to use if p is true
  
+     note that increasing z values are closer to the viewer
  
!  */
! 
! 
! 
! #define SETPIXEL(dptr,fptr,d,c)    if( (d) > *((dptr)+View.shift) )  \
!                                    {   *((dptr)+View.shift) = (d);  \
!                                        *((fptr)+View.shift) = (c);   \
                                     }
! #define SETPIXELP(dptr,fptr,d,c,ca,p) if( (d) > *((dptr)+View.shift))   \
!                                    {   *(dptr+View.shift) = (d);               \
!                                        if(!p) {*((fptr)+View.shift) = (c); }   \
!                                        else  {*((fptr)+View.shift) = (ca);}   \
                                     }
  
  #define OutCode(res,x,y,z)            \
***************
*** 273,281 ****
      /* SETPIXEL(dptr,fptr,z,Lut[col]); */
  
      offset = (Long)y*View.yskip+x;
!     dptr = View.dbuf+offset;
!     if( z > *dptr )
!     {   fptr = View.fbuf+offset;
          *fptr = Lut[col];
          *dptr = z;
      }
--- 310,318 ----
      /* SETPIXEL(dptr,fptr,z,Lut[col]); */
  
      offset = (Long)y*View.yskip+x;
!     dptr = View.dbuf+offset+View.shift;
!     if( OValid(offset) && z > *dptr )
!     {   fptr = View.fbuf+offset+View.shift;
          *fptr = Lut[col];
          *dptr = z;
      }
***************
*** 291,299 ****
      if( XValid(x) && YValid(y) && ZValid(z) && ZBack(z) )
      {   /* PlotPoint(x,y,z,col); */
          offset = (Long)y*View.yskip+x;
!         dptr = View.dbuf+offset;
!         if( z > *dptr )
!         {   fptr = View.fbuf+offset;
              *fptr = Lut[col];
              *dptr = z;
          }
--- 328,336 ----
      if( XValid(x) && YValid(y) && ZValid(z) && ZBack(z) )
      {   /* PlotPoint(x,y,z,col); */
          offset = (Long)y*View.yskip+x;
!         dptr = View.dbuf+offset+View.shift;
!         if( OValid(offset) && z > *dptr )
!         {   fptr = View.fbuf+offset+View.shift;
              *fptr = Lut[col];
              *dptr = z;
          }
***************
*** 309,318 ****
      register int inten;
  
      offset = (Long)y*View.yskip+x;
!     dptr = View.dbuf+offset;
  
!     if( z > *dptr )
!     {  fptr = View.fbuf+offset;
         inten = (ColourDepth*(z+ImageRadius-ZOffset))/ImageSize;
         if( inten > 0 )
         {   *fptr = Lut[col+(inten&ColourMask)];
--- 346,355 ----
      register int inten;
  
      offset = (Long)y*View.yskip+x;
!     dptr = View.dbuf+offset+View.shift;
  
!     if( OValid(offset) && z > *dptr )
!     {  fptr = View.fbuf+offset+View.shift;
         inten = (ColourDepth*(z+ImageRadius-ZOffset))/ImageSize;
         if( inten > 0 )
         {   *fptr = Lut[col+(inten&ColourMask)];
***************
*** 332,341 ****
      if( XValid(x) && YValid(y) && ZValid(z) && ZBack(z) )
      {   /* PlotDeepPoint(x,y,z,col); */
          offset = (Long)y*View.yskip+x;
!         dptr = View.dbuf+offset;
  
!         if( z > *dptr )
!         {  fptr = View.fbuf+offset;
             inten = (ColourDepth*(z+ImageRadius-ZOffset))/ImageSize;
             *fptr = Lut[col+inten];
             *dptr = z;
--- 369,378 ----
      if( XValid(x) && YValid(y) && ZValid(z) && ZBack(z) )
      {   /* PlotDeepPoint(x,y,z,col); */
          offset = (Long)y*View.yskip+x;
!         dptr = View.dbuf+offset+View.shift;
  
!         if( OValid(offset) && z > *dptr )
!         {  fptr = View.fbuf+offset+View.shift;
             inten = (ColourDepth*(z+ImageRadius-ZOffset))/ImageSize;
             *fptr = Lut[col+inten];
             *dptr = z;
***************
*** 391,397 ****
      fptr = View.fbuf+offset;
      dptr = View.dbuf+offset;
  
!     SETPIXEL(dptr,fptr,z1,c);
  
      dx = x2-x1;  dy = y2-y1; 
      if( !dx && !dy ) return;
--- 428,436 ----
      fptr = View.fbuf+offset;
      dptr = View.dbuf+offset;
  
!     if ( OValid(offset) ) {
!       SETPIXEL(dptr,fptr,z1,c);
!     }
  
      dx = x2-x1;  dy = y2-y1; 
      if( !dx && !dy ) return;
***************
*** 684,689 ****
--- 723,730 ----
  
  
  
+ 
+ 
  /*=============================================*/
  /*  Macros for 3D Bresenhams Vector Algorithm  */
  /*=============================================*/
***************
*** 731,737 ****
      fptr = View.fbuf+offset;
      dptr = View.dbuf+offset;
  
!     SETPIXEL(dptr,fptr,z1,Lut[col1+c1]);
  
      dx = x2 - x1;  dy = y2 - y1;
      dz = z2 - z1;  dc = c2 - c1;
--- 772,784 ----
      fptr = View.fbuf+offset;
      dptr = View.dbuf+offset;
  
!     if ( OValid(offset) ){
!       /* SETPIXEL(dptr,fptr,z1,Lut[col1+c1]); */
!       if ( z1 > *(dptr+View.shift) ) {
!         *(fptr+View.shift) = Lut[col1+c1];
!         *(dptr+View.shift) = z1;
!       }
!     }
  
      dx = x2 - x1;  dy = y2 - y1;
      dz = z2 - z1;  dc = c2 - c1;
***************
*** 1334,1342 ****
  
              dptr = dbase+xmin;
              for( x=xmin; x<xmax; x++ )
!             {   if( (int)(z>>16) > *dptr )
!                 {   fbase[x] = Lut[(int)(inten>>16)];
!                     *dptr = (int)(z>>16);
                  }
                  inten += di;
                  z += dz;
--- 1381,1389 ----
  
              dptr = dbase+xmin;
              for( x=xmin; x<xmax; x++ )
!             {   if( (int)(z>>16) > *(dptr+View.shift) )
!                 {   fbase[x+View.shift] = Lut[(int)(inten>>16)];
!                     *(dptr+View.shift) = (int)(z>>16);
                  }
                  inten += di;
                  z += dz;
***************
*** 1438,1446 ****
  
              dptr = dbase+xmin;
              for( x=xmin; x<xmax; x++ )
!             {   if( (int)(z>>16) > *dptr )
!                 {   fbase[x] = Lut[p->v[0].inten];
!                     *dptr = (int)(z>>16);
                  }
                  z += dz;
                  dptr++;
--- 1485,1493 ----
  
              dptr = dbase+xmin;
              for( x=xmin; x<xmax; x++ )
!             {   if( (int)(z>>16) > *(dptr+View.shift) )
!                 {   fbase[x+View.shift] = Lut[p->v[0].inten];
!                     *(dptr+View.shift) = (int)(z>>16);
                  }
                  z += dz;
                  dptr++;
***************
*** 1611,1618 ****
                  dptr = dbase+xmin;
                  for( x=xmin; x<xmax; x++ )
                  {   if( (int)(z>>16) > *dptr )
!                     {   fbase[x] = Lut[(int)(inten>>16)];
!                         *dptr = (int)(z>>16);
                      }
                      inten += di;
                      z += dz;
--- 1658,1665 ----
                  dptr = dbase+xmin;
                  for( x=xmin; x<xmax; x++ )
                  {   if( (int)(z>>16) > *dptr )
!                     {   fbase[x+View.shift] = Lut[(int)(inten>>16)];
!                         *(dptr+View.shift) = (int)(z>>16);
                      }
                      inten += di;
                      z += dz;
***************
*** 1772,1779 ****
                  dptr = dbase+xmin;
                  for( x=xmin; x<xmax; x++ )
                  {   if( (int)(z>>16) > *dptr )
!                     {   fbase[x] = Lut[p->v[0].inten];
!                         *dptr = (int)(z>>16);
                      }
                      z += dz;
                      dptr++;
--- 1819,1826 ----
                  dptr = dbase+xmin;
                  for( x=xmin; x<xmax; x++ )
                  {   if( (int)(z>>16) > *dptr )
!                     {   fbase[x+View.shift] = Lut[p->v[0].inten];
!                         *(dptr+View.shift) = (int)(z>>16);
                      }
                      z += dz;
                      dptr++;
***************
*** 2019,2036 ****
  
  #define UpdateAcross(dz)    \
          depth = (dz)+z;                    \
!         if( depth > *dptr )                \
!         {   *dptr = depth;                 \
              fptr = fold+dx;                \
              inten = LightDot(dx,dy,dz);    \
              if( inten>0 )                  \
!             {      inten = (int)((inten*ColConst[rad])>>ColBits); \
!                    *fptr = Lut[col+inten]; \
!             } else *fptr = Lut[col];       \
          }                                  \
          dptr++;  dx++;
  
! #define UpdateLine  \
          dx = -wide;                   \
          dptr = dold-wide;             \
          tptr = LookUp[wide]+wide;     \
--- 2066,2083 ----
  
  #define UpdateAcross(dz)    \
          depth = (dz)+z;                    \
!         if( depth > *(dptr+View.shift) )                \
!         {   *(dptr+View.shift) = depth;                 \
              fptr = fold+dx;                \
              inten = LightDot(dx,dy,dz);    \
              if( inten>0 )                  \
!             {      inten = (int)((inten*colconst(rad))>>ColBits); \
!                    *(fptr+View.shift) = Lut[col+inten]; \
!             } else *(fptr+View.shift) = Lut[col];       \
          }                                  \
          dptr++;  dx++;
  
! #define oUpdateLine  \
          dx = -wide;                   \
          dptr = dold-wide;             \
          tptr = LookUp[wide]+wide;     \
***************
*** 2039,2057 ****
          dold += View.yskip;  fold += View.yskip;             \
          dy++;
  
  
  void DrawSphere( int x, int y, int z, int rad, int col )
  {
      register Pixel __huge *fptr, __huge *fold;
      register short __huge *dptr, __huge *dold;
-     register Byte __far *tptr;
  
      register Long offset;
      register int depth,wide,inten;
      register int dx,dy;
  
      /* Avoid Lookup Table Overflow! */
!     if( rad > MAXRAD ) rad = MAXRAD;
  
      offset = (Long)(y-rad)*View.yskip + x;
      fold=View.fbuf+offset;  
--- 2086,2111 ----
          dold += View.yskip;  fold += View.yskip;             \
          dy++;
  
+ #define UpdateLine  \
+         dx = -wide;                   \
+         dptr = dold-wide;             \
+         while( dx<0 ) { UpdateAcross(pythag(wide,-dx));} \
+         do { UpdateAcross(pythag(wide,dx)); } while(dx<=wide); \
+         dold += View.yskip;  fold += View.yskip;             \
+         dy++;
+ 
  
  void DrawSphere( int x, int y, int z, int rad, int col )
  {
      register Pixel __huge *fptr, __huge *fold;
      register short __huge *dptr, __huge *dold;
  
      register Long offset;
      register int depth,wide,inten;
      register int dx,dy;
  
      /* Avoid Lookup Table Overflow! */
!     /* if( rad > MAXRAD ) rad = MAXRAD; */
  
      offset = (Long)(y-rad)*View.yskip + x;
      fold=View.fbuf+offset;  
***************
*** 2059,2075 ****
  
      dy = -rad;
      while( dy<0 ) 
!     {   wide = LookUp[rad][-dy]; 
          UpdateLine; 
      }
  
      do { 
!         wide = LookUp[rad][dy];  
          UpdateLine; 
      } while( dy<=rad );
  }
  
  
  void ClipSphere( int x, int y, int z, int rad, int col )
  {
      register Pixel __huge *fptr, __huge *fold;
--- 2113,2134 ----
  
      dy = -rad;
      while( dy<0 ) 
!     {   wide = pythag(rad,-dy); 
          UpdateLine; 
      }
  
      do { 
!         wide = pythag(rad,dy);  
          UpdateLine; 
      } while( dy<=rad );
  }
  
  
+ #ifndef max
+ #define max(a, b) ((a) < (b) ? (b) : (a))
+ #endif
+ 
+ 
  void ClipSphere( int x, int y, int z, int rad, int col )
  {
      register Pixel __huge *fptr, __huge *fold;
***************
*** 2080,2089 ****
      register int crad,cwide,temp;
      register Long offset;
  
-     /* Avoid Lookup Table Overflow! */
-     if( rad > MAXRAD ) rad = MAXRAD;
- 
-     /* Visibility Tests */
      if( !TestSphere(x,y,z,rad) )
          return;
  
--- 2139,2144 ----
***************
*** 2111,2123 ****
      /* No Slab Plane Clipping */
      if( !(ClipStatus&BitFront) )
      {   while( dy<=lasty )
!         {   wide = LookUp[rad][AbsFun(dy)];
              lastx = MinFun(wide,side);
              dx = - MinFun(wide,x);
              dptr = dold + dx;
  
              while( dx<=lastx )
!             {   dz = LookUp[wide][AbsFun(dx)];
                  UpdateAcross(dz);
              }
              dold += View.yskip;
--- 2166,2178 ----
      /* No Slab Plane Clipping */
      if( !(ClipStatus&BitFront) )
      {   while( dy<=lasty )
!         {   wide = pythag(rad,AbsFun(dy));
              lastx = MinFun(wide,side);
              dx = - MinFun(wide,x);
              dptr = dold + dx;
  
              while( dx<=lastx )
!             {   dz = pythag(wide,AbsFun(dx));
                  UpdateAcross(dz);
              }
              dold += View.yskip;
***************
*** 2128,2134 ****
      }
  
      dz = SlabValue-z;
!     crad = LookUp[rad][AbsFun(dz)];
   
      if( (z>SlabValue) || (SlabMode==SlabSection) )
      {   if( crad<lasty ) lasty = crad;
--- 2183,2189 ----
      }
  
      dz = SlabValue-z;
!     crad = pythag(rad,AbsFun(dz));
   
      if( (z>SlabValue) || (SlabMode==SlabSection) )
      {   if( crad<lasty ) lasty = crad;
***************
*** 2142,2176 ****
  
      while( dy<=lasty )
      {   temp = AbsFun(dy);
!         wide = LookUp[rad][temp];
          lastx = MinFun(wide,side);
          dx = - MinFun(x,wide);
          dptr = dold + dx;
  
          if( temp<=crad )
!         {   cwide = LookUp[crad][temp];
              while( dx<=lastx )
              {   temp = AbsFun(dx);
                  if( temp<=cwide )
                  {    /* Slab Plane Clipping Modes */
                      switch( SlabMode )
                      {   case( SlabFinal ):
!                                 fold[dx] = Lut[col+SlabInten];
!                                 *dptr = SliceValue;
                                  break;
  
                          case( SlabHollow ):
!                                 dz = LookUp[wide][temp];
                                  depth = z - dz;
!                                 if( depth>*dptr )
!                                 {   *dptr = depth;
                                      inten = LightDot(-dx,-dy,dz);
  
                                      if( inten>0 )
!                                     {   inten=(int)( (inten*ColConst[rad])
                                                       >>(ColBits+1));
!                                         fold[dx] = Lut[col+inten];
!                                     } else fold[dx] = Lut[col];
                                  }
                                  break;
  
--- 2197,2232 ----
  
      while( dy<=lasty )
      {   temp = AbsFun(dy);
!         wide = pythag(rad,temp);
          lastx = MinFun(wide,side);
          dx = - MinFun(x,wide);
          dptr = dold + dx;
  
          if( temp<=crad )
!         {   cwide = pythag(crad,temp);
              while( dx<=lastx )
              {   temp = AbsFun(dx);
                  if( temp<=cwide )
                  {    /* Slab Plane Clipping Modes */
                      switch( SlabMode )
                      {   case( SlabFinal ):
!                                 fold[dx+View.shift] = Lut[col+SlabInten];
!                                 *(dptr+View.shift) = SliceValue;
                                  break;
  
                          case( SlabHollow ):
!                                 dz = pythag(wide,temp);
                                  depth = z - dz;
!                                 if( depth>*(dptr+View.shift) )
!                                 {   *(dptr+View.shift) = depth;
                                      inten = LightDot(-dx,-dy,dz);
  
                                      if( inten>0 )
!                                     {   inten=(int)( (inten*colconst(rad))
                                                       >>(ColBits+1));
!                                         fold[dx+View.shift] =
!                                           Lut[col+inten];
!                                     } else fold[dx+View.shift] = Lut[col];
                                  }
                                  break;
  
***************
*** 2178,2192 ****
                          case( SlabClose ):
                                  dz = SlabValue-z;
                                  depth = dx*dx+dy*dy+dz*dz+SliceValue;
!                                 if( (*dptr<SliceValue) || (depth<*dptr) )
!                                 {   fold[dx] = Lut[col+SlabInten];
!                                     *dptr = depth;
                                  }
                                  break;
                      }
                      dptr++;  dx++;
                  } else if( (z<SlabValue) && (SlabMode!=SlabSection) )
!                 {    dz = LookUp[wide][temp];
                       UpdateAcross(dz);
                  } else
                  {   dptr++;  dx++;
--- 2234,2251 ----
                          case( SlabClose ):
                                  dz = SlabValue-z;
                                  depth = dx*dx+dy*dy+dz*dz+SliceValue;
!                                 if( (*(dptr+View.shift)
!                                   <SliceValue) ||
!                                   (depth<*(dptr+View.shift)) )
!                                 {   fold[dx+View.shift] = 
!                                       Lut[col+SlabInten];
!                                     *(dptr+View.shift) = depth;
                                  }
                                  break;
                      }
                      dptr++;  dx++;
                  } else if( (z<SlabValue) && (SlabMode!=SlabSection) )
!                 {    dz = pythag(wide,temp);
                       UpdateAcross(dz);
                  } else
                  {   dptr++;  dx++;
***************
*** 2194,2200 ****
              }
          } else /* Slabless ScanLine */
              while( dx<=lastx )
!             {   dz = LookUp[wide][AbsFun(dx)];
                  UpdateAcross(dz);
              }
  
--- 2253,2259 ----
              }
          } else /* Slabless ScanLine */
              while( dx<=lastx )
!             {   dz =pythag(wide,AbsFun(dx));
                  UpdateAcross(dz);
              }
  
